#ifndef IR_LIGHT_SOURCE_TRIANGLE_H
#define IR_LIGHT_SOURCE_TRIANGLE_H

#include "Ogre.h"
#include "IRSamplingType.h"

#define MAX_SAMPLES_PER_TRIANGLE 100

namespace IR
{

struct LightSourceTriangle
{
	Ogre::ColourValue m_Color;
	Ogre::Vector3 m_Vertices[3];
	Ogre::Vector3 m_Normal;
	Ogre::Vector3 m_Tangent;
	Ogre::Vector3 m_Samples[MAX_SAMPLES_PER_TRIANGLE];
	int numSamples;

	void computeSamples(int numSamples, SamplingType type);
};

};

#endif // IR_LIGHT_SOURCE_TRIANGLE_H