#ifndef IR_RAYCASTER_H
#define IR_RAYCASTER_H

//------------------------------------------------------------------------------
/**

*/

#include "OgreStableHeaders.h"

namespace IR {

	class RayCaster
	{
	public:
		RayCaster();
		virtual ~RayCaster(void) {};

		void onStateEnter(Ogre::String sceneManager);

		void onStateLeave();

		void onFrame();

		Ogre::Vector3 generateDirection(const Ogre::Real phi2,
										const Ogre::Real phi3,
										bool isHemisphere) const;

		bool createRay(Ogre::Ray* ray,
					   const Ogre::Vector3& origin,
					   const Ogre::Vector3& normal,
					   const Ogre::Vector3& tangent,
					   const Ogre::Real phi2,
					   const Ogre::Real phi3,
					   bool isHemisphere) const;

		bool intersectRay(const Ogre::Ray& ray,
						  Ogre::Vector3* intersection,
						  Ogre::Vector3* normal,
						  Ogre::Vector3* tangent,
						  Ogre::Entity** mesh);

	private:
		Ogre::SceneManager*	m_pSceneManager;
		Ogre::RaySceneQuery* m_pRaySceneQuery;

		Ogre::Vector3 m_sceneOrigin;
		Ogre::Quaternion m_sceneOrientation;
	};

}; // end namespace
#endif // IR_RAYCASTER_H