#include "IRApplication.h"

#include "IRGameState.h"

namespace IR {

Application::Application()
{
	Gear::Application::m_bOpen     = false;
	Gear::Application::m_bRunning  = false;
	Gear::Application::m_bPaused   = false;
	Gear::Application::m_Singleton = this;
}

Application::~Application() {}

bool Application::open()
{
	return Gear::Application::open();
}

void Application::close()
{
	Gear::Application::close();
}

void Application::run()
{
	Gear::Application::run();
}

void Application::setupStates()
{	
	// create Game State
	GameState* gameState = new GameState();
	gameState->setStateName("Game");
	gameState->setSceneManager(m_sSceneManager);

	// register States
	this->addState(gameState);

	// set active state
	this->setState("Game");
}

};